#ifndef SM_APP_H
#define SM_APP_H
/* THIS IS A GENERATED FILE -- DO NOT EDIT */
#include <stddef.h>
#include "w.h"
#include "basics.h"
#include "option.h"
#include "vec_t.h"
#include "tid_t.h"
#include "lid_t.h"
#include "sm_s.h"
#include "sm_base.h"
#include "file_s.h"
#include "page_s.h"
/* BEGIN VISIBLE TO APP */

/*
 * This file contains support for application programs to access
 * file page structures.
 *
 * It is used to generate common/sm_app.h.
 * 
 * Users should see sm/file_s.h for definitions of record_t.
 */

class shore_file_page_t : public page_s {

public:
    int slot_count() const { return nslots; }

    record_t* rec_addr(int idx) const {
	return ((idx > 0 && idx < nslots && slot[-idx].offset >=0) ? 
	        (record_t*) (data + slot[-idx].offset) : 
		0);
    }
};

/*
 * compile time constants also available from ss_m::config_info()
 *
 * The correctness of these constants is checked in ss_m::ss_m().
 */
class ssm_constants {
public: 
    enum {
	max_small_rec = page_s::data_sz - sizeof(file_p_hdr_t) -
			sizeof(page_s::slot_t) - sizeof(rectag_t),
	lg_rec_page_space = page_s::data_sz
    };
};

/* END VISIBLE TO APP */
#endif /* SM_APP_H */
